#pragma title("Simple Step Windows  Baudrate Window")
#pragma module(baud)
#pragma pagewidth(132)
#pragma pagelength(60)

/*
   ************************************************************************
   ************************************************************************
   **                                                                    **
   **   Module Name  : Baud.c                   Date : September 8, 1994 **
   **   Main Module  : WinMagCP.c               Version : 1.0            **
   **   Design By    : Charles R. Grenz         Company : Magna Assoc Inc**
   **   Designed for : Magna Assoc Inc          (C)opyright 1994 - 1995  **
   **                                           All Rights Reserved      **
   **   Notes :                                                          **
   **        This software belongs to the following company, and can not **
   **        be copied or used in any form without the express written   **
   **        permission of Magna Assoc Inc. If portions of this          **
   **        software are used in another project, then a notice that    **
   **        portions of this software where copied, and are copyrighted **
   **        by Magna Assoc Inc should be displayed.                     **
   **                                                                    **
   ************************************************************************
   ************************************************************************

    Version : 1.0 - 9/8/94
              History :
                 1 - Initial Release

*/

/* ***********************************************************************
                Link Date & Time Reference's for this module
   *********************************************************************** */

const char baudrate_date[] = {__DATE__};
const char baudrate_time[] = {__TIME__};
const char baudrate_file[] = {__FILE__};
const char baudrate_version[] = {"1.0.0"};

/**********************************************************************
 **********************************************************************/

#include <windows.h>

#include <dir.h>
#include <dos.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <ctype.h>

#include "const.h"
#include "SerialDLL32.h"
#include "sswincom32.h"

/*********************************************************************
                         Other Module Headers
 *********************************************************************/

 /*********************************************************************
                  Forward References for this module
 *********************************************************************/

extern DWord_T set_baudrate;

/*********************************************************************
                  Local Defines for this Module
 *********************************************************************/

/*********************************************************************
                  Local Variables for this Module
 *********************************************************************/

HWND     hDlgMOTOR_BAUDRATE;

/* ****************************************************************
**   Copyright (C) 1994-1995 Magna Assoc Inc
**   Magna Pump Control Panel
**
**   Function:
**
**   Description:
**
**
**   Inputs:          none
**   Returns:         none
**   Side Effects:    none
**   Author:          Charles R. Grenz
**   Changes:
**
*************************************************************** */

void show_port_data(HWND hDlg)
{
          switch (set_baudrate)
                 {
                  case 115200L :
                       CheckRadioButton(hDlg, IDC_RADIOBUTTON125, IDC_RADIOBUTTON130, IDC_RADIOBUTTON125);
                       break;
                  case 57600L :
                       CheckRadioButton(hDlg, IDC_RADIOBUTTON125, IDC_RADIOBUTTON130, IDC_RADIOBUTTON126);
                       break;
                  case 38400L :
                       CheckRadioButton(hDlg, IDC_RADIOBUTTON125, IDC_RADIOBUTTON130, IDC_RADIOBUTTON127);
                       break;
                  case 19200L :
                       CheckRadioButton(hDlg, IDC_RADIOBUTTON125, IDC_RADIOBUTTON130, IDC_RADIOBUTTON129);
                       break;
                  case 9600L :
                       CheckRadioButton(hDlg, IDC_RADIOBUTTON125, IDC_RADIOBUTTON130, IDC_RADIOBUTTON128);
                       break;
                  case 0L:
                       CheckRadioButton(hDlg, IDC_RADIOBUTTON125, IDC_RADIOBUTTON130, IDC_RADIOBUTTON130);
                       break;

                 } /* end of switch */

}

/* ****************************************************************
**   Copyright (C) 1994-1995 Magna Assoc Inc
**   Magna Pump Control Panel
**
**   Function:
**
**   Description:
**
**
**   Inputs:          none
**   Returns:         none
**   Side Effects:    none
**   Author:          Charles R. Grenz
**   Changes:
**
*************************************************************** */

#pragma argsused
BOOL FAR PASCAL fnMOTOR_BAUDRATEDlgProc(HWND hDlg, WORD wMessage, WORD wParam, LONG lParam)
{
   switch (wMessage)
          {
       case WM_INITDIALOG :
          CheckRadioButton(hDlg, IDC_RADIOBUTTON126, IDC_RADIOBUTTON126, IDC_RADIOBUTTON126);
          show_port_data(hDlg);
          return TRUE;

       case WM_COMMAND :
            switch(wParam)
            {
               case IDOK :
                    EndDialog(hDlg, TRUE);
                    return TRUE;

               case IDCANCEL :
                 EndDialog(hDlg, TRUE);
                 return FALSE;


               case IDC_RADIOBUTTON125 : /* BaudRate */
                  set_baudrate = 115200L;
                  return(TRUE);

               case IDC_RADIOBUTTON126 : /* BaudRate */
                  set_baudrate = 57600L;
                  return(TRUE);

               case IDC_RADIOBUTTON127 : /* BaudRate */
                  set_baudrate = 38400L;
                  return(TRUE);

               case IDC_RADIOBUTTON129 : /* BaudRate */
                  set_baudrate = 19200L;
                  return(TRUE);

               case IDC_RADIOBUTTON128 : /* BaudRate */
                  set_baudrate = 9600L;
                  return(TRUE);

               case IDC_RADIOBUTTON130 : /* BaudRate */
                  set_baudrate = 0L;
                  return(TRUE);

               default :
                 return FALSE;
            }

       case WM_SYSCOMMAND :
            switch(wParam & 0xFFF0)
            {
                case SC_CLOSE :
                     EndDialog(hDlg, FALSE);
                     return TRUE;
            }
   }
   return(FALSE);
}


/* ****************************************************************
**   Copyright (C) 1994-1995 Magna Assoc Inc
**   Magna Pump Control Panel
**
**   Function:
**
**   Description:
**
**
**   Inputs:          none
**   Returns:         none
**   Side Effects:    none
**   Author:          Charles R. Grenz
**   Changes:
**
*************************************************************** */

#pragma argsused
Boolean_T fnDL_MOTOR_BAUD(HWND hParentWnd)
{
Boolean_T   RetCode;
FARPROC  lpfnfnMOTOR_BAUDRATEDlgProc;

   lpfnfnMOTOR_BAUDRATEDlgProc = MakeProcInstance(fnMOTOR_BAUDRATEDlgProc, hInst);

   if ((RetCode = DialogBox(hInst, "BAUD_RATE", hParentWnd, lpfnfnMOTOR_BAUDRATEDlgProc)) == -1)
      {
       MessageBox(NULL,"Unable to Display 'BAUD_RATE' Dialog Box","Dialog Creation System Error", MB_OK | MB_ICONHAND | MB_SYSTEMMODAL);
       return(FALSE);
      }

   FreeProcInstance((FARPROC)lpfnfnMOTOR_BAUDRATEDlgProc);
   return(RetCode);
}

/* ***************************************************************************
   *************************************************************************** */








