

/*
   ************************************************************************
   ************************************************************************
   **                                                                    **
   **   Module Name  : Const.h                  Date : September 8, 1994 **
   **   Main Module  : ALL                      Version : 1.0            **
   **   Design By    : Charles R. Grenz         Company : Omicron Sys Prd**
   **   Designed for : Omicron System Products  (C)opyright 1994 - 1995  **
   **                                           All Rights Reserved      **
   **   Notes :                                                          **
   **        This software belongs to the following persons, and can not **
   **        be copied or used in any form without the express written   **
   **        permission of all the people listed. If portions of this    **
   **        software are used in another project, then a notice that    **
   **        portions of this software where copied, and are copyrighted **
   **        by Omicron System Products.                                 **
   **                                                                    **
   **                  Charles R. Grenz                                  **
   **                                                                    **
   ************************************************************************
   ************************************************************************ */

#define DWord_T                unsigned long int
#define Lint_T                 long int
#define Byte_T                 unsigned char
#define Word_T                 unsigned int
#define Boolean_T              int
#define Float_T                double
#define Mptr_T                 char far *

//#ifndef TRUE
//#define TRUE                   (Boolean_T) 0
//#define FALSE                  (Boolean_T) -1
//#endif

//#define mTRUE                   (Boolean_T) 0
//#define mFALSE                  (Boolean_T) -1

/*********************************************************************
                      Boolean Defines
 *********************************************************************/

#define GOOD               TRUE
#define BAD                FALSE

#define ON                 TRUE
#define OFF                FALSE

#define YES                TRUE
#define NO                 FALSE

#define OK                 TRUE
#define cERROR             FALSE

#define ACTIVE             TRUE
#define NOT_ACTIVE         FALSE

#define CODE               TRUE
#define NO_CODE            FALSE

#define ZNULL              (int) 0
#define ZERO               (Word_T)  0

#define SEND_ASCII_HEX     (int) 0
#define SEND_BINARY        (int) 1

/*********************************************************************
                Screen and Communication Defines
 *********************************************************************/

#define CNTL_A             (char) 0x01
#define CNTL_B             (char) 0x02
#define CNTL_C             (char) 0x03
#define CNTL_D             (char) 0x04
#define CNTL_E             (char) 0x05
#define CNTL_F             (char) 0x06
#define CNTL_G             (char) 0x07
#define CNTL_H             (char) 0x08
#define CNTL_I             (char) 0x09
#define CNTL_J             (char) 0x0a
#define CNTL_K             (char) 0x0b
#define CNTL_L             (char) 0x0c
#define CNTL_M             (char) 0x0d
#define CNTL_N             (char) 0x0e
#define CNTL_O             (char) 0x0f
#define CNTL_P             (char) 0x10
#define CNTL_Q             (char) 0x11
#define CNTL_R             (char) 0x12
#define CNTL_S             (char) 0x13
#define CNTL_T             (char) 0x14
#define CNTL_U             (char) 0x15
#define CNTL_V             (char) 0x16
#define CNTL_W             (char) 0x17
#define CNTL_X             (char) 0x18
#define CNTL_Y             (char) 0x19
#define CNTL_Z             (char) 0x1a

#define TOGGLE_WINDOWS     CNTL_R
#define CLR_SCRN           CNTL_Z          /* Televideo 910 - 975 & Lear */

#define ESCAPE             (char) 0x1d
#define ESC                (char) 27

#define F1_KEY             112
#define F2_KEY             113
#define F3_KEY             114
#define F4_KEY             115
#define F5_KEY             116
#define F6_KEY             117
#define F7_KEY             118
#define F8_KEY             119
#define F9_KEY             120
#define F10_KEY            121
#define F11_KEY            122
#define F12_KEY            123
#define ESCAPE_KEY         0x1b

#define CR                 CNTL_M
#define LF                 CNTL_J
#define BELL               CNTL_G
#define BACKSPACE          CNTL_H
#define TAB                CNTL_I

#define ACK                CNTL_F
#define NACK               CNTL_U
#define STX                CNTL_B
#define ETX                CNTL_C

#define HARD_RESET         CNTL_O       /* hard reset pumps */
#define XON                CNTL_Q       /* received - stops communications to host   transmitted - stop communications to all pumps */
#define XOFF               CNTL_S       /* received - start communications to host   transmitted - stop communications to all pumps */
#define MAGNA_RESET        CNTL_X       /* if recieved perform a hard reset with Magna Lang. startup */

#define XON_MESSAGE        "\x11"
#define XOFF_MESSAGE       "\x13"

/*********************************************************************
                    Bit Control Defines
 *********************************************************************/

#define  BIT_0             (Byte_T) 0x01
#define  BIT_1             (Byte_T) 0x02
#define  BIT_2             (Byte_T) 0x04
#define  BIT_3             (Byte_T) 0x08
#define  BIT_4             (Byte_T) 0x10
#define  BIT_5             (Byte_T) 0x20
#define  BIT_6             (Byte_T) 0x40
#define  BIT_7             (Byte_T) 0x80

#define  BIT_8             (Word_T) 0x0100
#define  BIT_9             (Word_T) 0x0200
#define  BIT_10            (Word_T) 0x0400
#define  BIT_11            (Word_T) 0x0800
#define  BIT_12            (Word_T) 0x1000
#define  BIT_13            (Word_T) 0x2000
#define  BIT_14            (Word_T) 0x4000
#define  BIT_15            (Word_T) 0x8000


#define MAX_PCOMMAND       20
#define MAX_MESSAGE_SIZE   50

#define MAX_CYCLES         10000

/*
typedef struct com {
                    Byte_T  pcommand;
                    Word_T  param[6];
                    Float_T paramf[6];
                    char    sparam[MAX_MESSAGE_SIZE];
                    char    scomment[MAX_MESSAGE_SIZE];
                   };
*/












