#pragma title("Windows Simple Step Control Module")
#pragma module(SSWin)
#pragma pagewidth(132)
#pragma pagelength(60)

/*
   ************************************************************************
   ************************************************************************
   **                                                                    **
   **   Module Name  : SSWin.c                  Date : November 28, 1997 **
   **   Main Module  : SSWin.c                  Version : 1.0.0          **
   **   Design By    : Charles R. Grenz         Company : Magna Assoc.Inc**
   **   Designed for : Magna Associates, Inc.   (C)opyright 1995-1998    **
   **                                           All Rights Reserved      **
   **   Notes :                                                          **
   **        This software belongs to the following persons, and can not **
   **        be copied or used in any form without the express written   **
   **        permission of all the people listed. If portions of this    **
   **        software are used in another project, then a notice that    **
   **        portions of this software where copied, and are copyrighted **
   **        by Magna Associates, Inc.                                   **
   **                                                                    **
   **                  Charles R. Grenz                                  **
   **                  Paul Webber                                       **
   **                                                                    **
   ************************************************************************
   ************************************************************************

    Version : 1.0.0 - 11/20/97
              History :
                 1 - Initial Release

*/

/* ***********************************************************************
                Link Date & Time Reference's for this module
   *********************************************************************** */

const char sswin_date[] = {__DATE__};
const char sswin_time[] = {__TIME__};
const char sswin_file[] = {__FILE__};
const char sswin_version[] = {"1.0.0.0"};

/**********************************************************************
 **********************************************************************/

#include <windows.h>

#include <dir.h>
#include <dos.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <ctype.h>

#include "const.h"
#include "serialdll32.h"
#include "SSWinCom32.h"

/*********************************************************************
                         Other Module Headers
 *********************************************************************/

/*********************************************************************
                  Forward References for this module
 *********************************************************************/

long FAR PASCAL MainWndProc(HWND, unsigned, WORD, LONG);

/*********************************************************************
                  Local Defines for this Module
 *********************************************************************/


 /*********************************************************************
                  Local Variables for this Module
 *********************************************************************/

Boolean_T program_mode = FALSE;
Boolean_T running_program = FALSE;

Boolean_T command_line_load = FALSE;

// Used in filename control dialog <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<

COLORREF crColor;
HFONT hfFont;
BOOL tfFontLoaded;

int default_loaded = FALSE;
int oldupdate = FALSE;

char wbuffer[400];
char buffer[100];

char message_buffer[200];
Word_T message_response;
Boolean_T done;

// Used in Time / Date Display <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<

struct time st;
struct time t;
struct date d;

HDC hdc, hdcMemory;
HBITMAP hbmpMyBitmap, hbmpOld;
BITMAP bm;

HANDLE    hInst;
HANDLE    hAccel;
HWND      hWndMain;
FARPROC   lpfnMainWndProc;
HMENU     hMenu;

HWND   current_dialog;
HWND   main_dialog;

Word_T  far wtemp;
Byte_T  far btemp;
Float_T far ftemp;
char    far stemp[150];
Boolean_T far result;


Word_T default_wait_timout = 90;
Word_T default_main_time = 250;
Word_T default_temp_time = 300;
Word_T default_das_time = 300;
Word_T default_encoder_time = 300;

char message_line[10];
char message_command[50];
char far message_system_messages[120];
char message_ad_channel[10];
char message_ad_value[20];
char message_ad_compare[20];
char message_dac0[10];
char message_dac1[10];
char message_input_port[10];
char message_output_port[10];
char message_comments[120];

char omessage_line[10];
char omessage_command[50];
char omessage_system_messages[120];
char omessage_comments[120];

Boolean_T abort_key = FALSE;
Boolean_T user_pause = FALSE;
Boolean_T stop_command =  FALSE;
Word_T user_select;
Boolean_T display_numbers;


Boolean_T far command_sent;

Boolean_T debugger_active;
Word_T run_position;
Boolean_T run_started;
Word_T ccount;
Boolean_T ccount_running;

DWord_T sstack;
Boolean_T init_run_mode;
DWord_T main_timer;
char xyzbuffer[100];

DWord_T set_baudrate;

/* ****************************************************************
**   Copyright (C) 1997-1998 Magna Associates, Inc.
**       All Rights Reserved.
**
**
**   Function:
**
**   Description:
**
**
**   Inputs:          none
**   Returns:         none
**   Side Effects:    none
**   Author:          Charles R. Grenz
**   Changes:
**
*************************************************************** */

Word_T far getsize(char far *msg)
{
Word_T p = 0;
char far *ptr;

  ptr = msg;
  while (*ptr != 0x00)
        {
         p++;
         ptr++;
        }

  return(p);
}

/* ****************************************************************
**   Copyright (C) 1997-1998 Magna Associates, Inc.
**       All Rights Reserved.
**
**
**   Function:
**
**   Description:
**
**
**   Inputs:          none
**   Returns:         none
**   Side Effects:    none
**   Author:          Charles R. Grenz
**   Changes:
**
*************************************************************** */

void far check_string_delimiter(char far *message)
{
Boolean_T found;

  found = FALSE;
  while (*message != 0)
        {
         if (*message == '\r')
            {
             found = TRUE;
            }
         message++;
        }
  if (found == FALSE)
     {
      *message = '\r';
      message++;
      *message = 0;
     }
}

/* ****************************************************************
**   Copyright (C) 1997-1998 Magna Associates, Inc.
**       All Rights Reserved.
**
**
**   Function:
**
**   Description:
**
**
**   Inputs:          none
**   Returns:         none
**   Side Effects:    none
**   Author:          Charles R. Grenz
**   Changes:
**
*************************************************************** */

Boolean_T far check_simple_step_status(char status, char far *response)
{
    switch (status)
           {
            case '>' :
                 _fstrcpy(response,"OK");
                 return(TRUE);

            case 'h' :
                 _fstrcpy(response,"Motor NOT Homed");
                 break;

            case '!' :
                 _fstrcpy(response,"Number Error");
                 break;

            case '#' :
                 _fstrcpy(response,"Syntax Error");
                 break;

            default :
                 sprintf(response, "?? '%c'",status);
                 return(TRUE);
           } // end of switch
   return(FALSE);
}

/* ****************************************************************
**   Copyright (C) 1997-1998 Magna Associates, Inc.
**       All Rights Reserved.
**
**
**   Function:
**
**   Description:
**
**
**   Inputs:          none
**   Returns:         none
**   Side Effects:    none
**   Author:          Charles R. Grenz
**   Changes:
**
*************************************************************** */

void far fix_xyz_string(char where, char far *data)
{
int p;

   p = 0;
   while (*data != 0x00)
         {
          if ((*data == 'X') || (*data == 'Y') || (*data == 'Z'))
             {
              xyzbuffer[p] = *data;
              p++;
              data++;
              xyzbuffer[p] = where;
              p++;
             }
          else
             {
              xyzbuffer[p] = *data;
              p++;
              data++;
             }
         }
  xyzbuffer[p] = 0x00;
}

/* ****************************************************************
**   Copyright (C) 1997-1998 Magna Associates, Inc.
**       All Rights Reserved.
**
**
**   Function:
**
**   Description:
**
**
**   Inputs:          none
**   Returns:         none
**   Side Effects:    none
**   Author:          Charles R. Grenz
**   Changes:
**
*************************************************************** */

Boolean_T far messageout(char far *msg)
{
  return(message_out(msg));
}

/* ****************************************************************
**   Copyright (C) 1997-1998 Magna Associates, Inc.
**       All Rights Reserved.
**
**
**   Function:
**
**   Description:
**
**
**   Inputs:          none
**   Returns:         none
**   Side Effects:    none
**   Author:          Charles R. Grenz
**   Changes:
**
*************************************************************** */

Boolean_T far messagein(char far *msg)
{
  return(message_in(msg));
}

/* ****************************************************************
**   Copyright (C) 1997-1998 Magna Associates, Inc.
**       All Rights Reserved.
**
**
**   Function:
**
**   Description:
**
**
**   Inputs:          none
**   Returns:         none
**   Side Effects:    none
**   Author:          Charles R. Grenz
**   Changes:
**
*************************************************************** */

Boolean_T near scommand(Byte_T board, Byte_T motor, char far *command)
{
Boolean_T old;
char badd;

   command_sent = TRUE;
   check_messages();
   clear_read_buffer();

	if (board < 10)
		{
		 badd = (char) (board + '0');
		}
	else
		{
		 badd = (char) ((board - 10) + 'A');
		}

	if (motor == S_MOTOR)
		{
		 sprintf(&message_sscb_select[0],"%u",board);
		 sprintf(&message_sscb_command[0],"D%c%s",badd,command);
		 check_string_delimiter(&message_sscb_command[0]);
		 messageout(&message_sscb_command[0]);
		 if (sscb[board] == FALSE)
			 {
			  _fstrcpy(&message_sscb_status[0],"NA");
			  command_sent = FALSE;
			  return(TRUE);
			 }
		}
	else if (motor == H_MOTOR)
		{
		 sprintf(&message_sscbhc_select[0],"%u",board);
		 sprintf(&message_sscbhc_command[0],"H%c%s",badd,command);
       check_string_delimiter(&message_sscbhc_command[0]);
       messageout(&message_sscbhc_command[0]);
       if (sscbhc[board] == FALSE)
          {
           _fstrcpy(&message_sscbhc_status[0],"NA");
           command_sent = FALSE;
           return(TRUE);
          }
      }
   else if (motor == Q_ENCODERS)
      {
       sprintf(&message_ssqe_select[0],"%u",board);
       sprintf(&message_ssqe_command[0],"Q%c%s",badd,command);
       check_string_delimiter(&message_ssqe_command[0]);
       messageout(&message_ssqe_command[0]);
       if (ssqe[board] == FALSE)
          {
           _fstrcpy(&message_ssqe_status[0],"NA");
           command_sent = FALSE;
           return(TRUE);
          }
      }
   else if ((motor == A_MOTOR) ||
            (motor == X_MOTOR) ||
            (motor == Y_MOTOR) ||
            (motor == Z_MOTOR)) // must be xyz then
      {
       sprintf(&message_ssxyz_select[0],"%u",board);
       fix_xyz_string(badd, command);
       _fstrcpy(&message_ssxyz_command[0],&xyzbuffer[0]);
       check_string_delimiter(&message_ssxyz_command[0]);
       messageout(&message_ssxyz_command[0]);
       if (ssxyz[board] == FALSE)
          {
           _fstrcpy(&message_ssxyz_status[0],"NA");
           command_sent = FALSE;
           return(TRUE);
          }
      }
   else // Just send the RS232 command string out no matter what it is.
      {
       messageout(command);
       command_sent = FALSE;
       return(TRUE);
      }

/* ############### Now Get response from Board ###################### */

   old = no_comm_messages;
   no_comm_messages = TRUE;
   if (wait_port(default_wait_timout) == TRUE) // wait for ack
      {
       if (motor == S_MOTOR)
          {
           messagein(&message_sscb_status[0]);
           if (check_simple_step_status(message_sscb_status[2], (char far *) &buffer[0]) == FALSE)
              {
               MessageBox(main_dialog,&buffer[0],"Simple Step SSCB Error",MB_OK | MB_ICONHAND | MB_SYSTEMMODAL);
               no_comm_messages = old;
               command_sent = FALSE;
               stop_command = TRUE;
               clear_read_buffer();
               return(FALSE);
              }
           if (message_sscb_status[3] != 0x0)
              {
               sstack = atol(&message_sscb_status[3]);
              }
          }
       else if (motor == H_MOTOR)
          {
           messagein(&message_sscbhc_status[0]);
           if (check_simple_step_status(message_sscbhc_status[2], (char far *) &buffer[0]) == FALSE)
              {
               MessageBox(main_dialog,&buffer[0],"Simple Step SSCB-HC Error",MB_OK | MB_ICONHAND | MB_SYSTEMMODAL);
               no_comm_messages = old;
               command_sent = FALSE;
               stop_command = TRUE;
               clear_read_buffer();
               return(FALSE);
              }
           if (message_sscbhc_status[3] != 0x0)
              {
               sstack = atol(&message_sscbhc_status[3]);
              }
          }
       else if ((motor == A_MOTOR) ||
                (motor == X_MOTOR) ||
                (motor == Y_MOTOR) ||
                (motor == Z_MOTOR))
          {
			  messagein(&message_ssxyz_status[0]);
           if (check_simple_step_status(message_ssxyz_status[2], (char far *) &buffer[0]) == FALSE)
              {
               MessageBox(main_dialog,&buffer[0],"Simple Step SSXYZ Error",MB_OK | MB_ICONHAND | MB_SYSTEMMODAL);
               no_comm_messages = old;
               command_sent = FALSE;
               stop_command = TRUE;
               clear_read_buffer();
               return(FALSE);
              }
           if (message_ssxyz_status[3] != 0x0)
              {
               sstack = atol(&message_ssxyz_status[3]);
              }
          }
       no_comm_messages = old;
       command_sent = FALSE;
       return(TRUE);
      }
   no_comm_messages = old;
   command_sent = FALSE;
   clear_read_buffer();
   return(FALSE);
}

/* ****************************************************************
**   Copyright (C) 1997-1998 Magna Associates, Inc.
**       All Rights Reserved.
**
**
**   Function:
**
**   Description:
**
**
**   Inputs:          none
**   Returns:         none
**   Side Effects:    none
**   Author:          Charles R. Grenz
**   Changes:
**
*************************************************************** */

Boolean_T far send_command(Byte_T board, Byte_T motor, char far *command)
{
Boolean_T result;
char buf[200];

        while (command_sent == TRUE)
               { /* wait here for completion */ }
         _fstrcpy(&buf[0], command);
         result = scommand(board, motor, command);
  return(result);
}

/* ****************************************************************
**   Copyright (C) 1997-1998 Magna Associates, Inc.
**       All Rights Reserved.
**
**
**   Function:
**
**   Description:
**
**
**   Inputs:          none
**   Returns:         none
**   Side Effects:    none
**   Author:          Charles R. Grenz
**   Changes:
**
*************************************************************** */

void no_help(void)
{
   MessageBeep(MB_ICONEXCLAMATION);
   MessageBox(GetFocus(),"No Help Implemented Yet. Please check the SSWin Manual.","SSWin Message",MB_OK | MB_ICONEXCLAMATION);
}

/* ****************************************************************
**   Copyright (C) 1997-1998 Magna Associates, Inc.
**       All Rights Reserved.
**
**
**   Function:
**
**   Description:
**
**
**   Inputs:          none
**   Returns:         none
**   Side Effects:    none
**   Author:          Charles R. Grenz
**   Changes:
**
*************************************************************** */

long FAR PASCAL MainWndProc(HWND hWnd, unsigned wMessage, WORD wParam, LONG lParam)
{
   switch (wMessage)
          {
           case WM_KEYDOWN :
                switch (wParam)
                       {
                        case 0x01b :   // Escape Key
                             MessageBeep(-1);
                             abort_key = TRUE;
                             KillTimer(main_dialog, MAIN_DIALOG);
                             PostQuitMessage(0);
                             return(TRUE);

                        case 0x0d :   // Escape Key
//                             next = TRUE;
                             break;
                  }
                return(TRUE);

       case WM_TIMER :
            switch(wParam)
                  {
                   case MAIN_DIALOG :
                        if (display_numbers == TRUE)
                           {
                            main_timer++;
                            display_numbers = TRUE;

                            SetDlgItemText(hWnd, IDC_SSCB_COMMAND,&message_sscb_command[0]);
                            SetDlgItemText(hWnd, IDC_SSCB_SELECTED,&message_sscb_select[0]);
                            SetDlgItemText(hWnd, IDC_SSCB_STATUS, &message_sscb_status[0]);

                            SetDlgItemText(hWnd, IDC_SSCBHC_COMMAND,&message_sscbhc_command[0]);
                            SetDlgItemText(hWnd, IDC_SSCBHC_SELECTED,&message_sscbhc_select[0]);
                            SetDlgItemText(hWnd, IDC_SSCBHC_STATUS, &message_sscbhc_status[0]);

                            SetDlgItemText(hWnd, IDC_SSXYZ_COMMAND,&message_ssxyz_command[0]);
                            SetDlgItemText(hWnd, IDC_SSXYZ_SELECTED,&message_ssxyz_select[0]);
                            SetDlgItemText(hWnd, IDC_SSXYZ_STATUS, &message_ssxyz_status[0]);

                            SetDlgItemText(hWnd, IDC_SSQE_COMMAND,&message_ssqe_command[0]);
                            SetDlgItemText(hWnd, IDC_SSQE_SELECTED,&message_ssqe_select[0]);
                            SetDlgItemText(hWnd, IDC_SSQE_STATUS, &message_ssqe_status[0]);

                           }
                        SetDlgItemText(hWnd, SYSTEM_MESSAGES,&message_system_messages[0]);

                        sprintf(&message_ssxyz_count[0], "%u", ssxyz_count);
                        sprintf(&message_sscb_count[0], "%u",sscb_count);
                        sprintf(&message_sscbhc_count[0], "%u",sscbhc_count);
                        sprintf(&message_ssqe_count[0], "%u",ssqe_count);
                        SetDlgItemText(hWnd, IDC_SSXYZ_COUNT, &message_ssxyz_count[0]);
                        SetDlgItemText(hWnd, IDC_SSCB_COUNT, &message_sscb_count[0]);
                        SetDlgItemText(hWnd, IDC_SSCBHC_COUNT, &message_sscbhc_count[0]);
                        SetDlgItemText(hWnd, IDC_SSQE_COUNT, &message_ssqe_count[0]);

                        UpdateWindow(main_dialog);
                        break;
                  } /* end of switch */
            return(TRUE);

           case WM_INITDIALOG :
                main_dialog = hWnd;
                run_position = 0;
                display_numbers = TRUE;
                return(TRUE);

           case WM_CLOSE :
                KillTimer(main_dialog, MAIN_DIALOG);
                PostQuitMessage(0);
                break;

           case WM_COMMAND :
                if (!LOWORD(lParam))
                   {                             // Process Menu Commands
                    switch (wParam)             // Determine which Menu ID
                           {
                            case CM_FILE_CHANGE_BAUDRATE :
                                 _fstrcpy(&message_system_messages[0],"Initializing Communications .......");
                                 UpdateWindow(hWndMain);
                                 fnDL_MOTOR_BAUD(hWnd);
                                 baudrate = set_baudrate;
                                 change_boards_baudrate(TRUE);
                                 message_system_messages[0] = 0x00;
                                 break;

                            case CM_FILEEXIT :
                                 PostQuitMessage(0);
                                 return(TRUE);
                           } // end of switch
                   }
                break;

           case WM_SYSCOMMAND :
                switch (wParam & 0xFFF0)
                       {
                        case SC_CLOSE :
                             KillTimer(main_dialog, MAIN_DIALOG);
                             PostQuitMessage(0);
                             return(TRUE);
                       } // end of switch

           default :
                return(FALSE);
          } // End of switch
   return(FALSE);
}

/* ****************************************************************
**   Copyright (C) 1997-1998 Magna Associates, Inc.
**       All Rights Reserved.
**
**
**   Function:
**
**   Description:
**
**
**   Inputs:          none
**   Returns:         none
**   Side Effects:    none
**   Author:          Charles R. Grenz
**   Changes:
**
*************************************************************** */

#pragma argsused
int PASCAL WinMain(HANDLE hInstance,       // Module instance handle
                   HANDLE hPrevInstance,   // Handle to previous module instance
                   LPSTR  lpszCmdLine,     // Pointer to command line arguments
                   int    nCmdShow)        // Show window flag
{
MSG      msg;
HWND     hWndMain;
int 		i;

   _fstrcpy(&wbuffer[0], lpszCmdLine);
   if (wbuffer[0] != 0)
      {
       command_line_load = TRUE;
       set_baudrate = (DWord_T) atol(&wbuffer[0]);
      }
   else
      {
       command_line_load = FALSE;
       set_baudrate = 57600L;
      }

   message_line[0] = 0x00;
   message_command[0] = 0x00;
   message_comments[0] = 0x00;
   message_sscb_command[0] = 0x00;
   message_system_messages[0] = 0x00;
   message_sscb_select[0] = 0x00;
   message_sscb_status[0] = 0x00;
   message_sscb_count[0] = 0x00;
   message_sscbhc_select[0] = 0x00;
   message_sscbhc_status[0] = 0x00;
   message_sscbhc_count[0] = 0x00;
   message_ssqe_select[0] = 0x00;
   message_ssqe_status[0] = 0x00;
   message_ssqe_count[0] = 0x00;
   message_ssxyz_select[0] = 0x00;
   message_ssxyz_status[0] = 0x00;
   message_ssxyz_count[0] = 0x00;
   message_ssxyz_count[0] = 0x00;

   omessage_line[0] = 0x00;
   omessage_command[0] = 0x00;
   omessage_system_messages[0] = 0x00;
   display_numbers = FALSE;
   main_timer = 0;

   command_sent = FALSE;

   hInst = hInstance;    // Store the application instance handle

hWndMain = CreateWindowEx(
    0,                      /* no extended styles          */
    "MainWClass",           /* class name                  */
    "MAIN_WINDOW",          /* window name                 */
    WS_OVERLAPPEDWINDOW |   /* overlapped window           */
        WS_HSCROLL |        /* horizontal scroll bar       */

        WS_VSCROLL,         /* vertical scroll bar         */
    CW_USEDEFAULT,          /* default horizontal position */
    CW_USEDEFAULT,          /* default vertical position   */
    CW_USEDEFAULT,          /* default width               */
    CW_USEDEFAULT,          /* default height              */
    (HWND) NULL,            /* no parent or owner window   */
    (HMENU) NULL,           /* class menu used             */
    hInst,              /* instance handle             */

    NULL);                  /* no window creation data     */


   hWndMain = CreateDialog(hInst,"MAIN_WINDOW", NULL, (DLGPROC) MainWndProc);

   if (hWndMain == NULL )
      {
       MessageBox(NULL,"Unable to Display 'MAIN_WINDOW' Dialog Box","Dialog Creation System Error",MB_OK | MB_ICONHAND | MB_SYSTEMMODAL);
       return(FALSE);
      }

   ShowWindow(hWndMain, nCmdShow | SW_RESTORE); //SW_RESTORE || SW_SHOWMAXIMIZED);
   UpdateWindow(hWndMain);

   default_loaded = TRUE;

   SetTimer(main_dialog, MAIN_DIALOG,(Word_T) default_main_time,NULL);

   if (command_line_load == FALSE)
      {
       fnDL_MOTOR_BAUD(hWndMain);
      }
   user_port = 1;  // Set for COM2
   default_wait_timout = 100;  // Set for 80ms timeout for messages

   _fstrcpy(&message_system_messages[0],"Initializing Communications .......");
   UpdateWindow(hWndMain);
   if (initialize_comm_module((Byte_T) user_port, set_baudrate, default_wait_timout, 0L) == FALSE)
      {
       MessageBox(NULL,"Unable to Initilaize Communications","System Error",MB_OK | MB_ICONHAND | MB_SYSTEMMODAL);
       return(FALSE);
      }
   message_system_messages[0] = 0x00;
   UpdateWindow(hWndMain);

   SetTimer(main_dialog, MAIN_DIALOG,(Word_T) default_main_time,NULL);

   while (GetMessage(&msg, NULL, 0, 0))
         {
          if (!IsDialogMessage(hWndMain, &msg))
          if (!TranslateAccelerator(hWndMain, hAccel, &msg))
             {
              TranslateMessage(&msg);
              DispatchMessage(&msg);
             }
         }

       no_comm_messages = TRUE;
       release_serial_port();

   FreeProcInstance((FARPROC)lpfnMainWndProc);
   return(msg.wParam);
}














